/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api;

import java.util.HashMap;
import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;

public interface Adapter {
	public static final String ADAPTER_CLASS_HEADER_NAME = "Entaxy-Adapter-Class";
	public static final String ADAPTER_HEADER_NAME = "Entaxy-Adapter";
	public default boolean isInited() {
		return false;
	}
	public default String getId() {
		return "none";
	}
	public default String getName() {
		return "Undefined";
	}
	public default String getDescription() {
		return "Undefined";
	}
	public default Map<String, String> getOptions() {
		return new HashMap<>();
	}
	public default Map<String, String> getProperties() {
		return new HashMap<>();
	}

/*
	@Deprecated
	public default Blueprint generateBlueprint(String type, Map<String, Object> map) throws Exception {
		return null;
	}
*/
	public default Generated generate(String type, Map<String, Object> map) throws Exception {
		return Generated.create();
	}

}
